//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3768133EFB33.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3768133EFB33.cm

//## begin module%3768133EFB33.cp preserve=no
//## end module%3768133EFB33.cp

//## Module: ComponentGroup%3768133EFB33; Package body
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/ComponentGroup.cxx

//## begin module%3768133EFB33.additionalIncludes preserve=no
//## end module%3768133EFB33.additionalIncludes

//## begin module%3768133EFB33.includes preserve=yes
//## end module%3768133EFB33.includes

// SumComponent
#include <XSModel/Model/Component/SumComponent.h>
// CGroupBase
#include <XSModel/Model/Component/CGroupBase.h>
// ComponentGroup
#include <XSModel/Model/Component/ComponentGroup.h>


//## begin module%3768133EFB33.declarations preserve=no
//## end module%3768133EFB33.declarations

//## begin module%3768133EFB33.additionalDeclarations preserve=yes
#include <XSUtil/Utils/XSutility.h>
#include <XSUtil/Parse/ModelExpression.h>
#include <XSUtil/Parse/ModelExprContexts.h>
//## end module%3768133EFB33.additionalDeclarations


// Class ComponentGroup::NoSuchComponent 

ComponentGroup::NoSuchComponent::NoSuchComponent (const string& msg)
  //## begin ComponentGroup::NoSuchComponent::NoSuchComponent%3A8D4A9C03B7.hasinit preserve=no
  //## end ComponentGroup::NoSuchComponent::NoSuchComponent%3A8D4A9C03B7.hasinit
  //## begin ComponentGroup::NoSuchComponent::NoSuchComponent%3A8D4A9C03B7.initialization preserve=yes
  //## end ComponentGroup::NoSuchComponent::NoSuchComponent%3A8D4A9C03B7.initialization
{
  //## begin ComponentGroup::NoSuchComponent::NoSuchComponent%3A8D4A9C03B7.body preserve=yes
  //## end ComponentGroup::NoSuchComponent::NoSuchComponent%3A8D4A9C03B7.body
}


// Class ComponentGroup 

//## begin ComponentGroup::GROUPTEST%3E8C7F4100B8.attr preserve=no  public: static string {VC} "$GROUP"
const string ComponentGroup::s_GROUPTEST = "$GROUP";
//## end ComponentGroup::GROUPTEST%3E8C7F4100B8.attr

ComponentGroup::ComponentGroup(const ComponentGroup &right)
  //## begin ComponentGroup::ComponentGroup%3628077800B4_copy.hasinit preserve=yes
      : m_groupBase(right.m_groupBase->clone())
  //## end ComponentGroup::ComponentGroup%3628077800B4_copy.hasinit
  //## begin ComponentGroup::ComponentGroup%3628077800B4_copy.initialization preserve=yes
  //## end ComponentGroup::ComponentGroup%3628077800B4_copy.initialization
{
  //## begin ComponentGroup::ComponentGroup%3628077800B4_copy.body preserve=yes
  //## end ComponentGroup::ComponentGroup%3628077800B4_copy.body
}

ComponentGroup::ComponentGroup (ModelExpression<ModExprTreeMember>& gs, ModelBase* parent, bool nested)
  //## begin ComponentGroup::ComponentGroup%376812CCF250.hasinit preserve=yes
      : m_groupBase(new CGroupBase(gs,parent,nested))
  //## end ComponentGroup::ComponentGroup%376812CCF250.hasinit
  //## begin ComponentGroup::ComponentGroup%376812CCF250.initialization preserve=yes
  //## end ComponentGroup::ComponentGroup%376812CCF250.initialization
{
  //## begin ComponentGroup::ComponentGroup%376812CCF250.body preserve=yes
  //## end ComponentGroup::ComponentGroup%376812CCF250.body
}


ComponentGroup::~ComponentGroup()
{
  //## begin ComponentGroup::~ComponentGroup%3628077800B4_dest.body preserve=yes
  delete m_groupBase;
  //## end ComponentGroup::~ComponentGroup%3628077800B4_dest.body
}


ComponentGroup & ComponentGroup::operator=(const ComponentGroup &right)
{
  //## begin ComponentGroup::operator=%3628077800B4_assign.body preserve=yes
  ComponentGroup __temp(right);
  swap(__temp);
  return *this;
  //## end ComponentGroup::operator=%3628077800B4_assign.body
}



//## Other Operations (implementation)
void ComponentGroup::calculate (bool saveComponentFlux, bool frozen)
{
  //## begin ComponentGroup::calculate%376812CCF839.body preserve=yes
  m_groupBase->calculate(saveComponentFlux,frozen);
  //## end ComponentGroup::calculate%376812CCF839.body
}

void ComponentGroup::setElement (XSModExpTree<ComponentGroup*>& componentGroups)
{
  //## begin ComponentGroup::setElement%376812CCF83E.body preserve=yes
        m_groupBase->setElement(componentGroups);
  //## end ComponentGroup::setElement%376812CCF83E.body
}

bool ComponentGroup::operator > (const ComponentGroup& right) const
{
  //## begin ComponentGroup::operator>%39D3613800F2.body preserve=yes
  return !operator>(right);
  //## end ComponentGroup::operator>%39D3613800F2.body
}

ComponentGroup* ComponentGroup::clone () const
{
  //## begin ComponentGroup::clone%3A843801021D.body preserve=yes
  return  new ComponentGroup(*this);
  //## end ComponentGroup::clone%3A843801021D.body
}

const ComponentList& ComponentGroup::elements () const
{
  //## begin ComponentGroup::elements%3A8C4406009E.body preserve=yes
 return m_groupBase->elements();
  //## end ComponentGroup::elements%3A8C4406009E.body
}

bool ComponentGroup::operator < (const ComponentGroup& right) const
{
  //## begin ComponentGroup::operator<%3A8C445D013A.body preserve=yes
  bool result (false);
  if ( m_groupBase->componentInfo()->group() > right.m_groupBase->componentInfo()->group() ) 
  {
          return true;
  }
  else 
  {
        if ( m_groupBase->componentInfo()->group() == right.m_groupBase->componentInfo()->group() )
        {
                if (m_groupBase->componentInfo()->location() 
                        > right.m_groupBase->componentInfo()->location()) result =  true;
        }
  }
  return result;
  //## end ComponentGroup::operator<%3A8C445D013A.body
}

const Component* ComponentGroup::getElements (const string& componentName) const
{
  //## begin ComponentGroup::getElements%3A8C4E1A00CF.body preserve=yes
  ComponentListConstIterator comp(m_groupBase->elements().begin());
  ComponentListConstIterator compEnd(m_groupBase->elements().end());
  while ( comp != compEnd )
  {
        if  (  (*comp)->name() == componentName ) break;
        
        ++comp;       
  }
  if ( comp != compEnd ) return *comp;
  // fix this.
  else throw Component::NoSuchComponent(componentName);
  //## end ComponentGroup::getElements%3A8C4E1A00CF.body
}

void ComponentGroup::setElements (const string& componentName, const Component* value)
{
  //## begin ComponentGroup::setElements%3A8C4E5401FC.body preserve=yes
  m_groupBase->setElements(componentName,value);
  //## end ComponentGroup::setElements%3A8C4E5401FC.body
}

void ComponentGroup::resetComponentFlux () const
{
  //## begin ComponentGroup::resetComponentFlux%3CB5F0D7034D.body preserve=yes
  //## end ComponentGroup::resetComponentFlux%3CB5F0D7034D.body

  m_groupBase->resetComponentFlux();
}

void ComponentGroup::swap (ComponentGroup& right) throw ()
{
  //## begin ComponentGroup::swap%3A8D499A02CF.body preserve=yes
  std::swap(m_groupBase,right.m_groupBase);
  //## end ComponentGroup::swap%3A8D499A02CF.body
}

SumComponent* ComponentGroup::groupFlux ()
{
  //## begin ComponentGroup::groupFlux%3A8D5901003F.body preserve=yes
  //## end ComponentGroup::groupFlux%3A8D5901003F.body

  return m_groupBase->groupFlux();
}

void ComponentGroup::registerParameters () const
{
  //## begin ComponentGroup::registerParameters%3A9EA58400FE.body preserve=yes
  m_groupBase->registerParameters();
  //## end ComponentGroup::registerParameters%3A9EA58400FE.body
}

Parameter* ComponentGroup::localParameter (size_t i) const
{
  //## begin ComponentGroup::localParameter%3AA938390374.body preserve=yes
  //## end ComponentGroup::localParameter%3AA938390374.body

  return m_groupBase->localParameter(i);
}

bool ComponentGroup::isNested () const
{
  //## begin ComponentGroup::isNested%3AE855D200E0.body preserve=yes
  //## end ComponentGroup::isNested%3AE855D200E0.body

  return m_groupBase->nested();
}

const SumComponent* ComponentGroup::sum () const
{
  //## begin ComponentGroup::sum%3AE86837010E.body preserve=yes
  //## end ComponentGroup::sum%3AE86837010E.body

  return m_groupBase->groupFlux();
}

void ComponentGroup::checkNorms (IntegerArray& paramsToFreeze) const
{
  //## begin ComponentGroup::checkNorms%3C89157C02A8.body preserve=yes
  //## end ComponentGroup::checkNorms%3C89157C02A8.body

  m_groupBase->checkNorms(paramsToFreeze);
}

void ComponentGroup::setComputeFlag (bool value)
{
  //## begin ComponentGroup::setComputeFlag%3C20EC90030F.body preserve=yes
  //## end ComponentGroup::setComputeFlag%3C20EC90030F.body

  m_groupBase->setComputeFlag(value);
}

std::list<ModParam*> ComponentGroup::normParams () const
{
  //## begin ComponentGroup::normParams%3C6D2FAB01CB.body preserve=yes
  //## end ComponentGroup::normParams%3C6D2FAB01CB.body

  return m_groupBase->normParams();
}

void ComponentGroup::clearArrays (const std::set<UniqueEnergy*>& currentEngs)
{
  //## begin ComponentGroup::clearArrays%3C7670A30172.body preserve=yes
  m_groupBase->clearArrays(currentEngs);
  //## end ComponentGroup::clearArrays%3C7670A30172.body
}

std::vector<ModParam*> ComponentGroup::getVariableParameters () const
{
  //## begin ComponentGroup::getVariableParameters%3C7BA4B801C1.body preserve=yes
  //## end ComponentGroup::getVariableParameters%3C7BA4B801C1.body

  return m_groupBase->getVariableParameters();
}

void ComponentGroup::saveComponentFlux () const
{
  //## begin ComponentGroup::saveComponentFlux%3CB71C0B012E.body preserve=yes
  //## end ComponentGroup::saveComponentFlux%3CB71C0B012E.body

  m_groupBase->saveComponentFlux();
}

void ComponentGroup::combine ()
{
  //## begin ComponentGroup::combine%3D08C0D10146.body preserve=yes
  //## end ComponentGroup::combine%3D08C0D10146.body

  m_groupBase->combine();
}

void ComponentGroup::parent (ModelBase* p)
{
  //## begin ComponentGroup::parent%3DD003D402E5.body preserve=yes
  //## end ComponentGroup::parent%3DD003D402E5.body

  m_groupBase->parent(p);
}

std::list<SumComponent*> ComponentGroup::sources ()
{
  //## begin ComponentGroup::sources%3DE7A5B401CC.body preserve=yes
  //## end ComponentGroup::sources%3DE7A5B401CC.body

  return m_groupBase->sources();
}

void ComponentGroup::deleteComponent (int sequenceNumber, int index)
{
  //## begin ComponentGroup::deleteComponent%3EF9EBED027D.body preserve=yes
  m_groupBase->deleteComponent(sequenceNumber,index);
  //## end ComponentGroup::deleteComponent%3EF9EBED027D.body
}

void ComponentGroup::setNestedElement (const string& componentName, Component* value)
{
  //## begin ComponentGroup::setNestedElement%3F01F44401AA.body preserve=yes
  m_groupBase->setNestedElement(componentName,value);
  //## end ComponentGroup::setNestedElement%3F01F44401AA.body
}

void ComponentGroup::resetElement (XSModExpTree<ComponentGroup*>& newGroups, const std::vector<Component*>& existingComponents)
{
  //## begin ComponentGroup::resetElement%3F1EBBA6027A.body preserve=yes
    m_groupBase->resetElement(newGroups,existingComponents);
  //## end ComponentGroup::resetElement%3F1EBBA6027A.body
}

Component* ComponentGroup::componentByNumber (int index) const
{
  //## begin ComponentGroup::componentByNumber%3F1ECC8A016D.body preserve=yes
  return m_groupBase->element(index);
  //## end ComponentGroup::componentByNumber%3F1ECC8A016D.body
}

void ComponentGroup::insertComponent (int location, int index, const string& name, char op)
{
  //## begin ComponentGroup::insertComponent%3F26BB8D026D.body preserve=yes
  m_groupBase->insertComponent(location,index,name,op);
  //## end ComponentGroup::insertComponent%3F26BB8D026D.body
}

void ComponentGroup::exchangeComponent (int location, Component* newComponent)
{
  //## begin ComponentGroup::exchangeComponent%4512A7490047.body preserve=yes
  m_groupBase->exchangeComponent(location, newComponent);
  //## end ComponentGroup::exchangeComponent%4512A7490047.body
}

Component* ComponentGroup::createComponent (string& name)
{
  //## begin ComponentGroup::createComponent%4512D996005E.body preserve=yes
    return m_groupBase->createComponent(name);
  //## end ComponentGroup::createComponent%4512D996005E.body
}

void ComponentGroup::deregisterParameters () const
{
  //## begin ComponentGroup::deregisterParameters%3F297F1F020D.body preserve=yes
  m_groupBase->deregisterParameters();
  //## end ComponentGroup::deregisterParameters%3F297F1F020D.body
}

Component* ComponentGroup::firstComponent ()
{
  //## begin ComponentGroup::firstComponent%3F72034001BF.body preserve=yes
  return m_groupBase->firstComponent();
  //## end ComponentGroup::firstComponent%3F72034001BF.body
}

void ComponentGroup::resizeElements (size_t n)
{
  //## begin ComponentGroup::resizeElements%405B5AD50087.body preserve=yes
    m_groupBase->resizeElements(n);
  //## end ComponentGroup::resizeElements%405B5AD50087.body
}

void ComponentGroup::addToElements (int componentOffset, Component* newComponent)
{
  //## begin ComponentGroup::addToElements%4134D0490138.body preserve=yes
    m_groupBase->addToElements(componentOffset, newComponent);
  //## end ComponentGroup::addToElements%4134D0490138.body
}

const ModelBase* ComponentGroup::parent () const
{
  //## begin ComponentGroup::parent%41361FF600B6.body preserve=yes
  return m_groupBase->parent();
  //## end ComponentGroup::parent%41361FF600B6.body
}

const ModelExpression<ModExprTreeMember>* ComponentGroup::componentInfo () const
{
  //## begin ComponentGroup::componentInfo%41362FB901F2.body preserve=yes
    return m_groupBase->componentInfo();
  //## end ComponentGroup::componentInfo%41362FB901F2.body
}

// Additional Declarations
  //## begin ComponentGroup%3628077800B4.declarations preserve=yes
  //## end ComponentGroup%3628077800B4.declarations

//## begin module%3768133EFB33.epilog preserve=yes
std::ostream & operator<<(std::ostream& s, const ComponentGroup& right)
{
  ComponentListConstIterator p = right.elements().begin();
  while (p != right.elements().end())
  {
	int w = (*p)->name().find("$GROUP");
	if ( w < 0 ) s << **p;
        ++p;
  }  
  return s;      
}

void ComponentGroup::setComponentInfo(ModelExpression<ModExprTreeMember>* expr)
{
        m_groupBase->componentInfo(expr);       
}
//## end module%3768133EFB33.epilog
